<div id="user-folder" @drop.prevent="scanFiles" @dragover.prevent="uploadOverlay = true" @dragleave.prevent="uploadOverlay = false" v-cloak>

  <router-view></router-view>

  
  <div class="container d-flex flex-column flex-grow-1" v-if="!notFound && !loading" v-cloak>

    <div class="row my-2">
      <span id="folderPath" class="mb-2"><span v-for="folder in pathFolders"><a class="btn btn-sm" v-on:click="goToFolderById(folder.folderId)">{{ decodeFileName(folder.folderName || '') }}</a>/</span><a v-if="dirData.id !== me.homeFolder" class="btn btn-sm" v-on:click="goToFolderById(dirData.id)">{{ decodeFileName(dirData.folderName || '') }}</a></span>
    </div>
    <div class="actionBar my-2 d-flex align-items-center">
      <input type="file" id="filePicker" name="filePicker" class="d-none" multiple>
      <a class="btn btn-sm btn-info mr-2" v-on:click="showFilePicker()"><i class="fas fa-plus"></i> Upload</a>
      <a class="btn btn-sm btn-info mr-2" v-on:click="modal = 'newFolder'"><i class="fas fa-folder"></i> New Folder</a>
      <a class="btn btn-sm btn-info mr-2" v-on:click="refreshFolder(true)"><i class="fas fa-sync-alt"></i> Refresh</a>
      <div class="ml-4 d-flex align-items-center" v-if="fileSelection.length || folderSelection.length">
        <span class="font-weight-bold">Selected {{ fileSelection.length + folderSelection.length }} :</span>
        <a class="btn btn-sm btn-info ml-2" v-on:click="downloadSelected()">Download</a>
        <a class="btn btn-sm btn-danger ml-2" v-on:click="removeSelected()">Delete</a>
      </div>
    </div>
    <div class="table-responsive flex-grow-1" :class="uploadOverlay? 'uploadOverlay': ''" >
      <table class="table table-sm flex-grow-1">
        <thead>
          <tr>
            <th scope="col" class="itemCheckboxCol">
              <div class="form-check">
                <input class="form-check-input position-static" type="checkbox" id="selectAllCheckbox" v-model="selectAll">
              </div>
            </th>
            <th scope="col" class="itemIconCol"> </th>
            <th scope="col"><button class="btn btn-sm btn-outline" v-on:click="sortByName()">Name <span v-if="sort === 'name'"><i class="fas" :class="order === 'ASC' ? 'fa-angle-up': 'fa-angle-down'"></i></span></button></th>
            <th scope="col" class="mobileHide"><button class="btn btn-sm btn-outline" v-on:click="sortBySize()">Size <span v-if="sort === 'size'"><i class="fas" :class="order === 'ASC' ? 'fa-angle-up': 'fa-angle-down'"></i></span></button></th>
            <th scope="col" class="mobileHide"><button class="btn btn-sm btn-outline" v-on:click="sortByCreatedAt()">Created <span v-if="sort === 'createdAt'"><i class="fas" :class="order === 'ASC' ? 'fa-angle-up': 'fa-angle-down'"></i></span></button></th>
            <th scope="col"></th>
          </tr>
        </thead>
        <tbody >
          <tr v-for="folder in folders"> 
            <th scope="row" class="itemCheckboxCell">
              <div class="itemCheckbox">
                <input class="itemCheckbox" type="checkbox" :id="folder.id" :value="folder.id" v-model="folderSelection">
              </div>
            </th>
            <td><span class="flex-cell"><span class="itemIcon"><i :class="folder.action === 'remove' ? 'fas fa-trash-alt': 'fas fa-folder'"></i></span></td>
            <td><span class="flex-cell"><a class="btn listBtn" :class="folder.action === 'remove' ? 'text-muted' : null" v-on:click="folder.action !== 'remove' ? goToFolderById(folder.id) : null">{{ decodeFileName(folder.folderName) }}</a></span></td>
            <td class="mobileHide itemSizeCell"></td>
            <td class="mobileHide itemTimestampCell"><span class="flex-cell"><js-timestamp :at="folder.createdAt"></js-timestamp></span></td>
            <td class="itemDropdownCell">
              <div class="btn-group">
                <button type="button" class="btn dropdown-toggle listBtn" data-toggle="dropdown" data-display="static">
                  <i class="fas fa-ellipsis-h"></i>
                </button>
                <div class="dropdown-menu dropdown-menu-right">
                  <button class="dropdown-item" type="button">Browse</button>
                  <button class="dropdown-item" type="button">Info</button>
                  <button class="dropdown-item" type="button">Share</button>
                  <button class="dropdown-item text-danger" type="button" v-on:click="removeOneFolder(folder.id)">Delete</button>
                </div>
              </div>
            </td>
          </tr>
          <tr v-for="file in files">
            <th scope="row" class="itemCheckboxCell">
              <div class="itemCheckbox">
                <input class="itemCheckbox" type="checkbox" :id="file.id" :value="file.id" v-model="fileSelection">
              </div>
            </th>
            <td><span class="flex-cell"><span  class="itemIcon"><i :class="file.action === 'upload' ? 'far fa-file' : file.action === 'remove'? 'fas fa-trash-alt' : 'fas fa-exclamation-circle'"></i></span></td>
            <td><span class="flex-cell"><a class="btn listBtn" v-on:click="downloadFile(file.id, file.fileName)">{{ decodeFileName(file.fileName) }}</a></span></td>
            <td class="mobileHide itemSizeCell"><span class="flex-cell"><js-filesize :size="file.contentLength"></js-filesize></span></td>
            <td class="mobileHide itemTimestampCell"><span class="flex-cell"><js-timestamp :at="file.createdAt"></js-timestamp></span></td>
            <td class="itemDropdownCell">
              <div class="btn-group">
                <button type="button" class="btn dropdown-toggle listBtn" data-toggle="dropdown" data-display="static">
                  <i class="fas fa-ellipsis-h"></i>
                </button>
                <div class="dropdown-menu dropdown-menu-right">
                  <button class="dropdown-item" type="button">Info</button>
                  <button class="dropdown-item" type="button">Download</button>
                  <button class="dropdown-item" type="button">Share</button>
                  <button class="dropdown-item text-danger" type="button" v-on:click="removeOneFile(file.id)">Delete</button>
                </div>
              </div>
            </td>
          </tr>
        </tbody>
      </table>
    </div>



  </div>

  <div class="loader-container" v-if="uploading" v-cloak>
    <span class="loader mx-2"><i class="fas fa-circle-notch fa-spin"></i></span>
    <div class="mx-2 d-block">
      <span><js-transfer-rate :rate="uploadRate" :round=2></js-transfer-rate></span><br>
      <span>{{ uploadCount }}/{{ requestCount }} items</span><br>
      <span><js-filesize :size="uploadSize + uploadProgressSize"></js-filesize>/<js-filesize :size="requestSize"></js-filesize></span>
    </div>
  </div>

  <div class="container d-flex justify-content-center align-items-center" v-if="notFound" v-cloak>
    <div class="text-center">
      <h1>404</h1>
      <h3>The folder cannot be found!</h3>
      <a class="btn btn-info mt-4" href="/folder">Go back to your home folder</a>
    </div>
  </div>


  <modal v-if="modal === 'newFolder'" @close="closeModal()" v-cloak>
    <div class="modal-header">
      <h2 class="modal-title">New Folder</h2>
      <p class="modal-intro">At: {{ path }}</p>
      <hr>
    </div>

    <div class="modal-body">
      <label for="newFolderName">Folder name</label>
      <div class="input-group mb-3">
        <input type="text" id="newFolderName" class="form-control" v-model="formData.newFolderName" v-on:keyup.enter="createFolder(dirData.id, formData.newFolderName)" focus-first>
      </div>

      <div id="newFolderNameFeedback" class="invalid-feedback" v-if="formError.folderName">
        Please provide a valid folder name.
      </div>

      <small id="folderNameHelpText" class="form-text text-muted" v-if="formError.folderName">
        <ul>
          <li>Between 1 and 256 characters.</li>
          <li>Cannot contain the character: ":"</li>
          <li>Some characters are not supported on Windows systems: \/?*:"|<></li>
        </ul>
      </small>

      <div class="d-flex justify-content-center">
        <button class="btn btn-info text-center" v-on:click="createFolder(dirData.id, formData.newFolderName)">Create</button>
      </div>
    </div>
  </modal>


</div>
<%- /* Expose server-rendered data as window.SAILS_LOCALS :: */ exposeLocalsToBrowser() %>
